--[[

]]--
local addonName, vars = ...
local L = vars.L --- localizzazione
local ERA = _G[addonName]

--Upvalue
local format, tconcat, tinsert, tsort, UnitClass, UnitExists, IsInGroup, GetNumGroupMembers, UnitGroupRolesAssigned = string.format, table.concat, table.insert, table.sort, UnitClass, UnitExists, IsInGroup, GetNumGroupMembers, UnitGroupRolesAssigned

function ERA:ClassColoredName(unit)
   local _,class = UnitClass(unit)
   local color = RAID_CLASS_COLORS[class]
   return(format("\|c%s%s\|r", color.colorStr,GetUnitName(unit)))
end

--ritorna una tabella contente nelle prime 3 posizioni numero contato, dps totali e morti.
function ERA:TargetingList(what, inverse)
	--what puo' essere focus o target. altri valori sono errori di codice
	if not what or (what ~= "focus" and what ~= "target") then return {format("\|cFFFF0000 Error what = %s\|r",what or "nil")}  end
	--se non c'è trget o focus lo diciamo
	if not UnitExists(what) then return {format("\|cFFFF0000No %s\|r",what)}  end
	local where = ERA:IsGrouped()
	--se non siamo in gruppo il frame non serve
	if not where then 
	  return {L["\|cFFFF0000Not in group\|r"]}
	end   
	local role,who   
	local m = GetNumGroupMembers()
	local n, dps,dead = 0 , 0 , 0
	local list = {}
	for i = 1, m do
	  who = where..i
	  if where == "party" and i == m then who = "player"end
	  role = UnitGroupRolesAssigned(who)         
	  if role ~= "TANK" and role ~= "HEALER" then
		 if not UnitIsDead(who) then
		   dps = dps+1		   
			if (not inverse and UnitIsUnit(what,who.."target")) or (inverse and not UnitIsUnit(what,who.."target")) then
			   n = n + 1			   
			   tinsert(list, ERA:ClassColoredName(who))
			end
		 else
			dead = dead+1			
		 end
	  end      
	end

	if n == 0 then tinsert(list, L["\|cFFFF0000NO ONE\|r"]) end
	tsort(list)
	return list,n, dps,dead
end

function ERA:DpsCountOn(what)
	if not ERA[what] then return end    
	local inverse = ERA:AssistMonitorListOrder(what)	
	local list, n, dps, dead = ERA:TargetingList(what, inverse)
	list = tconcat(list,"\n")	
	if n then 
		ERA[what].txt:SetFormattedText("%s%2d\/%2d DPS -%2d \|T%s:0\|t%s\n%s", not inverse and "" or "\|cFFFF0000", n, dps, dead, ERA:GetTexture("Lapide"), not inverse and "" or "\|r", list)			
	else
		ERA[what].txt:SetFormattedText("%s",list)
	end
end

function ERA:CreateAssistMonitor(what)
	if not ERA[what] then
		local monitor = {closable=false,class = ERA.monitorClass,type=what,savePos=true,title = ERA:Upper1(what),titleColor = "g",}
		ERA[what] = ERA:Frame(monitor)      
		ERA:SetFrameVal(ERA[what],"counter", 0)      
		ERA[what]:SetScript("OnUpdate", function(self, elapsed)           
            ERA:SetFrameVal(self, "counter", ERA:GetFrameVal(self, "counter") + elapsed)
            if ERA:GetFrameVal(self, "counter") > ERA.delay then
               ERA:SetFrameVal(self, "counter", 0)
               ERA:DpsCountOn(ERA:GetFrameVal(self,"type"))
            end
		end)       
	end      
end

function ERA:ShowAssistMonitor(what)
	if what and (what == "focus" or what == "target") then
		if not ERA[what] then ERA:CreateAssistMonitor(what) end
		ERA[what]:Show()
	end
end

local function GetAssistMonitorDB()
	return ERA:DB()["assistMonitor"]
end

function ERA:AssistMonitorListOrder(what)
	return GetAssistMonitorDB()[what].inverti
end

function ERA:HideAssistMonitor(what)
	if what and (what == "focus" or what == "target") and ERA[what] then    
		ERA[what]:Hide()
	end
end

function ERA:IsMonitorEnabled(what)
	if what then    
		return GetAssistMonitorDB()[what].attiva
	end
end

function ERA:IsMonitorRaidOnly(what)
	if what then    
		return GetAssistMonitorDB()[what].raidOnly
	end
end

function ERA:IsMonitornotLFR(what)
	if what then    
		return GetAssistMonitorDB()[what].notInLFR
	end
end

function ERA:IsMonitorTest(what)
	if what and (what == "focus" or what == "target") then    
		return ERA["_"..what.."MonitorTest"]
	end
end

function ERA:CanMonitorBeShown(what)
	if ERA:IsMonitorEnabled(what) and (
		(IsInGroup() or IsInRaid())
		and (not ERA:IsMonitorRaidOnly(what) or IsInRaid())
		and (not ERA:IsMonitornotLFR(what) or (select(3, GetInstanceInfo())) ~= 17)
	)
	then return true
	end
end
